structure CPSTop :> CONVERT_TOP
             where type kind = IL3.kind
               and type con = IL3.con
               and type term = IL3.exp =
  ConvertTopFn(struct
              structure In =
                struct
                  type kind = IL3.kind
                  type con = IL3.con
                  type term = IL3.exp
                            
                  exception Check = IL3Static.Check
                  exception Error = IL3Static.Error

                  val kind_to_layout = IL3Print.kind_to_layout
                  val con_to_layout = IL3Print.con_to_layout
                  val term_to_layout = IL3Print.exp_to_layout
                end
              
              structure Out =
                struct
                  type kind = IL4.kind
                  type con = IL4.con
                  type term =
                    IL3.con * {k : IL4.expvar, k_exn : IL4.expvar} * IL4.exp

                  val kind_to_layout = IL4Print.kind_to_layout
                  val con_to_layout = IL4Print.con_to_layout
                  fun term_to_layout (t, {k, k_exn}, e) =
                    let
                      val $ = Layout.str
                      fun var x = $(Variable.toString x)
                    in
                      Layout.align[
                        Layout.seq [var k, $", ", var k_exn, $"."],
                        IL4Print.exp_to_layout e,
                        $":",
                        IL3Print.con_to_layout t
                      ]
                    end
                end

               exception Convert = CPSConvert.Convert
               exception Error = CPSConvert.Error

               val convert_kind = CPSConvert.convert_kind
               val convert_con = CPSConvert.convert_con
               val convert_term = CPSConvert.convert_exp IL3Static.Ctx.empty
             end)
