signature IL3STATIC =
  sig
    structure Ctx : CONTEXT
                       where type con = IL3.con
                         and type kind = IL3.kind

    type context = Ctx.context

    exception Equiv
    exception Check of string
    exception Error of string

    (* raise Equiv if false *)
    val equiv_con : context -> IL3.con -> IL3.con -> IL3.kind -> unit

    val whnf : IL3.con -> IL3.con

    (* expand a projection from a ConMu into its substitution instance *)
    val expand : context -> IL3.con -> IL3.con

    val synth_con_kind : context -> IL3.con -> IL3.kind
    val check_con_kind : context -> IL3.con -> IL3.kind -> string -> unit

    val synth_exp_con : context -> IL3.exp -> IL3.con
    val check_exp_con : context -> IL3.exp -> IL3.con -> string -> unit
  end
